=== debian/changelog ===
prismlauncher (7.2+ds-1deepin2) unstable; urgency=medium

  * fix: cannot build due to pointer and iterator type conversions

 -- sisungo <sisungo@icloud.com>  Fri, 17 Oct 2025 21:56:00 +0800

prismlauncher (7.2+ds-1deepin1) unstable; urgency=medium

  * Move distribution to unstable

 -- Chang Yang <yangchang@deepin.org>  Thu, 31 Aug 2023 18:55:00 +0800

prismlauncher (7.2+ds-1) UNRELEASED; urgency=medium

  * Initial Package (Closes: #898972)

 -- Ben Westover <me@benthetechguy.net>  Mon, 07 Aug 2023 16:30:10 -0400
