=== debian/control ===
Source: prismlauncher
Section: contrib/games
Priority: optional
Maintainer: Ben Westover <me@benthetechguy.net>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 pkg-config,
 openjdk-17-jdk,
 zlib1g-dev,
 libgl-dev,
 libquazip1-qt6-dev,
 libtomlplusplus-dev,
 libcmark-dev,
 gamemode-dev,
 qt6-base-dev,
 qt6-base-dev-tools,
 libqt6core5compat6-dev,
 libqt6core6,
 libqt6network6,
 qtchooser,
 scdoc,
 cmark
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/BenTheTechGuy/prismlauncher.git
Vcs-Browser: https://salsa.debian.org/BenTheTechGuy/prismlauncher
Homepage: https://prismlauncher.org
Rules-Requires-Root: no

Package: prismlauncher
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, java-runtime (>= 16) | openjdk-17-jre
Suggests: java-runtime (= 8) | openjdk-8-jre
Provides: multimc, polymc
Description: FOSS Minecraft launcher supporting multiple instances and accounts
 Prism Launcher is a custom launcher for Minecraft that allows users to
 create multiple instances and use multiple accounts. As a fork of the
 popular MultiMC, it focuses on user freedom, stability, & simplicity.
